<script lang="ts">
import Vue from 'vue';
import { SlpColumn, SlpContainer } from '../../common/index.vue';
import { Accordion } from '../index.vue';

export default Vue.extend({
  name: 'BySolutionBenefits',
  components: { SlpColumn, SlpContainer, Accordion },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      isOpenIndex: 0 as any,
    };
  },
  methods: {
    toggleController(index: number) {
      if (this.isOpenIndex === index) {
        this.isOpenIndex = null;
        return;
      }
      this.isOpenIndex = index;
    },
  },
});
</script>

<template>
  <section class="by-solution-benefits slp-py-48 slp-py-md-96">
    <SlpContainer>
      <div class="slp-mb-16 slp-mb-md-64">
        <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-8">
          <span
            :data-aos="data.header_animation"
            :data-aos-duration="data.header_duration"
            >{{ data.title }}</span
          >
        </SlpTypography>
      </div>
      <SlpRow>
        <SlpColumn :cols="6" class="slp-pr-md-16">
          <div class="by-solution-benefits__image">
            <img
              :src="data.image.image_url"
              alt=""
              aria-hidden="true"
              :data-aos="data.left_block_animation"
              :data-aos-duration="data.left_block_duration"
            />
          </div>
        </SlpColumn>
        <SlpColumn :cols="6" class="slp-pl-md-16">
          <div
            :data-aos="data.right_block_animation"
            :data-aos-duration="data.right_block_duration"
          >
            <div
              v-if="data.is_accordion"
              class="by-solution-benefits__items-wrapper"
            >
              <Accordion
                v-for="(item, index) in data.items"
                :key="item.header"
                :data="item"
                :is-open="isOpenIndex == index"
                @toggleController="toggleController(index)"
              />
            </div>
            <div v-else class="by-solution-benefits__items-wrapper">
              <div
                v-for="(item, index) in data.items"
                :key="item.header"
                class="slp-pb-16 slp-mb-32"
                :class="{
                  'by-solution-benefits__items-w-border':
                    index !== data.items.length - 1,
                }"
              >
                <SlpTypography
                  tag="h3"
                  variant="heading5"
                  class="by-solution-benefits__header"
                >
                  <img
                    v-if="item.icon"
                    class="by-solution-benefits__icon"
                    :src="item.icon"
                    alt=""
                    aria-hidden="true"
                  />
                  {{ item.header }}
                </SlpTypography>
                <SlpTypography variant="body1" tag="p" v-html="item.text" />
              </div>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.by-solution-benefits {
  &__image {
    position: relative;
    margin-bottom: $spacing-48;

    img {
      max-width: 450px;
      width: 100%;
    }
  }

  &__items-wrapper {
    max-width: 540px;
    width: 100%;

    @media (max-width: 1169px) {
      max-width: 100%;
    }
  }

  &__icon {
    margin-right: $spacing-default;
  }

  &__header {
    display: flex;
    align-items: center;
    font-weight: $font-weight-bold;
    padding-bottom: $spacing-16;
    margin-bottom: $spacing-4;
  }

  &__items-w-border {
    border-bottom: 1px solid $color-surface-200;
  }
}
</style>
